# ChangesOfVariables.jl

[![Documentation for stable version](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaMath.github.io/ChangesOfVariables.jl/stable)
[![Documentation for development version](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaMath.github.io/ChangesOfVariables.jl/dev)
[![License](http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](LICENSE.md)
[![Build Status](https://github.com/JuliaMath/ChangesOfVariables.jl/workflows/CI/badge.svg)](https://github.com/JuliaMath/ChangesOfVariables.jl/actions?query=workflow%3ACI)
[![Codecov](https://codecov.io/gh/JuliaMath/ChangesOfVariables.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaMath/ChangesOfVariables.jl)


ChangesOfVariables.jl defines functionality to calculate volume element
changes for functions that perform a change of variables (like coordinate
transformations).

`ChangesOfVariables` is a very lightweight package and has no dependencies
beyond `Base` and `LinearAlgebra` (plus a weak dependency on `InverseFunctions`
and `Test`).

## Documentation

* [Documentation for stable version](https://JuliaMath.github.io/ChangesOfVariables.jl/stable)
* [Documentation for development version](https://JuliaMath.github.io/ChangesOfVariables.jl/dev)

# Use
#
#     DOCUMENTER_DEBUG=true julia --color=yes make.jl local [nonstrict] [fixdoctests]
#
# for local builds.

using Documenter
using ChangesOfVariables

# Doctest setup
DocMeta.setdocmeta!(
    ChangesOfVariables,
    :DocTestSetup,
    :(using ChangesOfVariables, InverseFunctions);
    recursive=true,
)

makedocs(
    sitename = "ChangesOfVariables",
    modules = [ChangesOfVariables],
    format = Documenter.HTML(
        prettyurls = !("local" in ARGS),
        canonical = "https://JuliaMath.github.io/ChangesOfVariables.jl/stable/"
    ),
    pages = [
        "Home" => "index.md",
        "API" => "api.md",
        "LICENSE" => "LICENSE.md",
    ],
    doctest = ("fixdoctests" in ARGS) ? :fix : true,
    linkcheck = !("nonstrict" in ARGS),
    warnonly = ("nonstrict" in ARGS),
)

deploydocs(
    repo = "github.com/JuliaMath/ChangesOfVariables.jl.git",
    forcepush = true,
    push_preview = true,
)

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).

using Test
using ChangesOfVariables
using InverseFunctions

const ChangesOfVariablesInverseFunctionsExt = Base.get_extension(ChangesOfVariables, :ChangesOfVariablesInverseFunctionsExt)
const InverseFunctionWithLADJ = ChangesOfVariablesInverseFunctionsExt.InverseFunctionWithLADJ

include("getjacobian.jl")


# Dummy testing type that looks like something that represents abstract zeros:
struct _Zero{T} end
_Zero(::T) where {T} = _Zero{T}()


@testset "setladj" begin
    @test @inferred(setladj(Real, _Zero)) isa ChangesOfVariables.FunctionWithLADJ{Type{Real},Type{_Zero}}
    @test @inferred(ChangesOfVariables.FunctionWithLADJ(Real, _Zero)) isa ChangesOfVariables.FunctionWithLADJ{Type{Real},Type{_Zero}}
    @test @inferred(ChangesOfVariables.FunctionWithLADJ(widen, _Zero)) isa ChangesOfVariables.FunctionWithLADJ{typeof(widen),Type{_Zero}}
    @test @inferred(ChangesOfVariables.FunctionWithLADJ(Real, zero)) isa ChangesOfVariables.FunctionWithLADJ{Type{Real},typeof(zero)}
    @test @inferred(ChangesOfVariables.FunctionWithLADJ(widen, zero)) isa ChangesOfVariables.FunctionWithLADJ{typeof(widen),typeof(zero)}

    @test @inferred(InverseFunctionWithLADJ(Real, _Zero)) isa InverseFunctionWithLADJ{Type{Real},Type{_Zero}}
    @test @inferred(InverseFunctionWithLADJ(widen, _Zero)) isa InverseFunctionWithLADJ{typeof(widen),Type{_Zero}}
    @test @inferred(InverseFunctionWithLADJ(Real, zero)) isa InverseFunctionWithLADJ{Type{Real},typeof(zero)}
    @test @inferred(InverseFunctionWithLADJ(widen, zero)) isa InverseFunctionWithLADJ{typeof(widen),typeof(zero)}

    @test @inferred(setladj(setladj(exp, x -> 0), x -> x)) isa ChangesOfVariables.FunctionWithLADJ{typeof(exp)}
    ChangesOfVariables.test_with_logabsdet_jacobian(setladj(setladj(exp, x -> 0), x -> x), 1.7, getjacobian)

    x = 4.2
    y = x^2

    f_fwd = setladj(x -> x^2, x -> log(2*x))
    f_inv = setladj(y -> sqrt(y), y -> log(inv(2*sqrt(y))))
    ChangesOfVariables.test_with_logabsdet_jacobian(f_fwd, x, getjacobian)
    ChangesOfVariables.test_with_logabsdet_jacobian(f_inv, y, getjacobian)

    f = @inferred setladj(setinverse(x -> x^2, x -> sqrt(x)), x -> log(2*x))
    @test @inferred(f(x)) == y
    ChangesOfVariables.test_with_logabsdet_jacobian(f, x, getjacobian)
    ChangesOfVariables.test_with_logabsdet_jacobian(inverse(f), y, getjacobian)
    ChangesOfVariables.test_with_logabsdet_jacobian(inverse(inverse(f)), x, getjacobian)
    @inferred(inverse(inverse(f))) isa ChangesOfVariables.FunctionWithLADJ

    @static if isdefined(InverseFunctions, :setinverse)
        g = setinverse(f_fwd, f_inv)
        ChangesOfVariables.test_with_logabsdet_jacobian(g, x, getjacobian)
        ChangesOfVariables.test_with_logabsdet_jacobian(inverse(g), y, getjacobian)
        ChangesOfVariables.test_with_logabsdet_jacobian(inverse(inverse(g)), x, getjacobian)
    end
end

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).

if !isdefined(Main, :getjacobian)

import ForwardDiff

torv_and_back(V::AbstractVector{<:Real}) = V, identity
torv_and_back(x::Real) = [x], V -> V[1]
torv_and_back(x::Complex) = [real(x), imag(x)], V -> Complex(V[1], V[2])
torv_and_back(x::NTuple{N}) where N = [x...], V -> ntuple(i -> V[i], Val(N))

function torv_and_back(x::Ref)
    xval = x[]
    V, to_xval = torv_and_back(xval)
    back_to_ref(V) = Ref(to_xval(V))
    return (V, back_to_ref)
end

torv_and_back(A::AbstractArray{<:Real}) = vec(A), V -> reshape(V, size(A))

function torv_and_back(A::AbstractArray{Complex{T}, N}) where {T<:Real, N}
    RA = cat(real.(A), imag.(A), dims = N+1) 
    V, to_array = torv_and_back(RA)
    function back_to_complex(V)
        RA = to_array(V)
        Complex.(view(RA, map(_ -> :, size(A))..., 1), view(RA, map(_ -> :, size(A))..., 2))
    end
    return (V, back_to_complex)
end


function getjacobian(f, x)
    V, to_x = torv_and_back(x)
    vf(V) = torv_and_back(f(to_x(V)))[1]
    ForwardDiff.jacobian(vf, V)
end

end # !isdefined(Main, :getjacobian)


if !isdefined(Main, :foo)

foo(x) = inv(exp(-x) + 1)

end # !isdefined(Main, :foo)


if !isdefined(Main, :bar)

# with_logabsdet_jacobian for floats but not for integers 
bar(x) = x
ChangesOfVariables.with_logabsdet_jacobian(::typeof(bar), x::AbstractFloat) = (x, zero(x))

end # !isdefined(Main, :bar)

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).

using ChangesOfVariables
using Test

using LinearAlgebra

using ChangesOfVariables: test_with_logabsdet_jacobian

include("getjacobian.jl")


@testset "torv_and_back" begin
    for x in (rand(3), 0.5, Complex(0.2,0.7), (3,5,9), Ref(42), rand(3, 4, 5), Complex.(rand(3,5), rand(3,5)))
        V, to_x = torv_and_back(x)
        @test V isa AbstractVector{<:Real}
        @test V == torv_and_back(x)[1]
        @test x isa Ref ? to_x(V)[] == x[] : to_x(V) == x
    end
end


@testset "test_with_logabsdet_jacobian" begin
    rx = 0.5
    cx = Complex(0.2, -0.7)
    X = rand(3, 3)
    CX = Complex.(randn(3,3), randn(3,3))

    myisapprox(a, b; kwargs...) = isapprox(a, b; kwargs...)

    noninferrable_inv(x) = x!=rand(size(x)...) ? inv(x) : ""
    ChangesOfVariables.with_logabsdet_jacobian(::typeof(noninferrable_inv), x) = noninferrable_inv(x), with_logabsdet_jacobian(inv, x)[2]
    @test_throws ErrorException @inferred with_logabsdet_jacobian(noninferrable_inv, rand(2, 2))

    test_with_logabsdet_jacobian(inv, rx, ForwardDiff.derivative, atol = 10^-6)
    test_with_logabsdet_jacobian(inv, cx, getjacobian, atol = 10^-6)
    test_with_logabsdet_jacobian(inv, X, ForwardDiff.jacobian, atol = 10^-6)
    test_with_logabsdet_jacobian(inv, CX, getjacobian, atol = 10^-6)
    test_with_logabsdet_jacobian(inv, CX, getjacobian, atol = 10^-6)
    test_with_logabsdet_jacobian(inv, CX, getjacobian, compare = myisapprox, atol = 10^-6)
    test_with_logabsdet_jacobian(noninferrable_inv, CX, getjacobian, atol = 10^-6)
end

module ChangesOfVariablesInverseFunctionsExt

using ChangesOfVariables
using InverseFunctions


struct InverseFunctionWithLADJ{InvF,LADJF} <: Function
    inv_f::InvF
    ladjf::LADJF
end
InverseFunctionWithLADJ(::Type{InvF}, ladjf::LADJF) where {InvF,LADJF} = InverseFunctionWithLADJ{Type{InvF},LADJF}(InvF,ladjf)
InverseFunctionWithLADJ(inv_f::InvF, ::Type{LADJF}) where {InvF,LADJF} = InverseFunctionWithLADJ{InvF,Type{LADJF}}(inv_f,LADJF)
InverseFunctionWithLADJ(::Type{InvF}, ::Type{LADJF}) where {InvF,LADJF} = InverseFunctionWithLADJ{Type{InvF},Type{LADJF}}(InvF,LADJF)

(f::InverseFunctionWithLADJ)(y) = f.inv_f(y)

function ChangesOfVariables.with_logabsdet_jacobian(f::InverseFunctionWithLADJ, y)
    x = f.inv_f(y)
    return x, -f.ladjf(x)
end

InverseFunctions.inverse(f::ChangesOfVariables.FunctionWithLADJ) = InverseFunctionWithLADJ(inverse(f.f), f.ladjf)
InverseFunctions.inverse(f::InverseFunctionWithLADJ) = ChangesOfVariables.FunctionWithLADJ(inverse(f.inv_f), f.ladjf)


@static if isdefined(InverseFunctions, :FunctionWithInverse)
    function ChangesOfVariables.with_logabsdet_jacobian(f::InverseFunctions.FunctionWithInverse, x)
        ChangesOfVariables.with_logabsdet_jacobian(f.f, x)
    end
end

end # module ChangesOfVariablesInverseFunctionsExt

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).

"""
    ChangesOfVariables

Lightweight package that defines functionality to calculate volume element
changes for functions that perform a change of variables (like coordinate
transformations).
"""
module ChangesOfVariables

using LinearAlgebra

include("with_ladj.jl")
include("setladj.jl")

"""
    ChangesOfVariables.test_with_logabsdet_jacobian(f, x, getjacobian; compare = isapprox, kwargs...)

Test if [`with_logabsdet_jacobian(f, x)`](@ref) is implemented correctly.

Checks if the result of `with_logabsdet_jacobian(f, x)` is approximately
equal to `(f(x), logabsdet(getjacobian(f, x)))`
        
So the test uses `getjacobian(f, x)` to calculate a reference Jacobian for
`f` at `x`. Passing `ForwardDiff.jabobian`, `Zygote.jacobian` or similar as
the `getjacobian` function will do fine in most cases. If input and output
of `f` are real scalar values, use `ForwardDiff.derivative`.

Note that the result of `getjacobian(f, x)` must be a real-valued matrix
or a real scalar, so you may need to use a custom `getjacobian` function
that transforms the shape of `x` and `f(x)` internally, in conjunction
with automatic differentiation.

`kwargs...` are forwarded to `compare`.

!!! Note
    You have to load the `Test` standard library to be able to use this function.
"""
function test_with_logabsdet_jacobian end

# Better error message if users forget to load Test
function __init__()
    Base.Experimental.register_error_hint(MethodError) do io, exc, _, _
        if exc.f === test_with_logabsdet_jacobian &&
            (Base.get_extension(ChangesOfVariables, :ChangesOfVariablesTest) === nothing)
            print(io, "\nDid you forget to load Test?")
        end
    end
end

end # module

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).

import Test
import ChangesOfVariables
import Documenter

Test.@testset "Package ChangesOfVariables" begin
    include("test_test.jl")
    include("test_with_ladj.jl")
    include("test_setladj.jl")

    # doctests
    Documenter.DocMeta.setdocmeta!(
        ChangesOfVariables,
        :DocTestSetup,
        :(using ChangesOfVariables, InverseFunctions);
        recursive=true,
    )
    Documenter.doctest(ChangesOfVariables)
end # testset

module ChangesOfVariablesTestExt

using Test: @inferred, @test, @testset
using ChangesOfVariables: ChangesOfVariables, logabsdet, with_logabsdet_jacobian

function ChangesOfVariables.test_with_logabsdet_jacobian(f, x, getjacobian; compare = isapprox, kwargs...)
    @testset "test_with_logabsdet_jacobian: $f with input $x" begin
        ref_y, test_type_inference = try
            @inferred(f(x)), true
        catch err
            f(x), false
        end

        y, ladj = if test_type_inference
            @inferred with_logabsdet_jacobian(f, x)
        else
            with_logabsdet_jacobian(f, x)
        end

        ref_ladj = _generalized_logabsdet(getjacobian(f, x))[1]
    
        @test compare(y, ref_y; kwargs...)
        @test compare(ladj, ref_ladj; kwargs...)
    end
    return nothing
end

_generalized_logabsdet(A) = logabsdet(A)
_generalized_logabsdet(x::Real) = log(abs(x))

end # module

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).

using ChangesOfVariables
using Test

using LinearAlgebra

using ChangesOfVariables
using ChangesOfVariables: test_with_logabsdet_jacobian

include("getjacobian.jl")


@testset "with_logabsdet_jacobian" begin
    _bc_func(f) = Base.Broadcast.BroadcastFunction(f)

    @test with_logabsdet_jacobian(sum, rand(5)) === NoLogAbsDetJacobian(sum, rand(5))
    @test with_logabsdet_jacobian(log ∘ sum, 5.0f0) === NoLogAbsDetJacobian(log ∘ sum, 5.0f0)
    @test_throws MethodError _, _ = with_logabsdet_jacobian(sum, rand(5))

    @test with_logabsdet_jacobian(sin, 4.9) === NoLogAbsDetJacobian{typeof(sin), Float64}()
    @test with_logabsdet_jacobian(String, 4.9) === NoLogAbsDetJacobian{Type{String}, Float64}()
    @test with_logabsdet_jacobian(String, Float64) === NoLogAbsDetJacobian{Type{String}, Type{Float64}}()
    @test with_logabsdet_jacobian(sin, Float64) === NoLogAbsDetJacobian{typeof(sin), Type{Float64}}()

    @test with_logabsdet_jacobian(sin ∘ log, 4.9) === NoLogAbsDetJacobian{typeof(sin ∘ log), Float64}()
    @test with_logabsdet_jacobian(log ∘ sin, 4.9) === NoLogAbsDetJacobian{typeof(log ∘ sin), Float64}()

    @test with_logabsdet_jacobian(Base.Fix1(broadcast, sin), 4.9) === NoLogAbsDetJacobian(Base.Fix1(broadcast, sin), 4.9)

    function ChangesOfVariables.with_logabsdet_jacobian(::typeof(foo), x)
        y = foo(x)
        ladj = -x + 2 * log(y)
        (y, ladj)
    end

    x = 4.2
    X = rand(10)
    A = rand(5, 5)
    CA = Complex.(rand(5, 5), rand(5, 5))

    isaprx(a, b; kwargs...) = isapprox(a,b; kwargs...)
    isaprx(a::NTuple{N,Any}, b::NTuple{N,Any}; kwargs...) where N = all(map((a,b) -> isaprx(a, b; kwargs...), a, b))


    test_with_logabsdet_jacobian(foo, x, getjacobian)

    test_with_logabsdet_jacobian(log ∘ foo, x, getjacobian)

    @testset "with_logabsdet_jacobian on mapped and broadcasted" begin
        for f in (_bc_func(foo), Base.Fix1(map, foo), Base.Fix1(broadcast, foo))
            for arg in (x, fill(x,), Ref(x), (x,), (x, 2*x, 3*x), X)
                test_with_logabsdet_jacobian(f, arg, getjacobian, compare = isaprx)
            end
        end
    end

    @testset "with_logabsdet_jacobian on mapped and broadcasted without ladj" begin
        for f in (_bc_func(sin), Base.Fix1(map, sin), Base.Fix1(broadcast, sin))
            for arg in (x, (x,), (x, x), X)
                @test with_logabsdet_jacobian(f, arg) === NoLogAbsDetJacobian(f, arg)
            end
        end
    end

    @testset "with_logabsdet_jacobian on mapped and broadcasted with mixed ladj" begin
        @test with_logabsdet_jacobian(_bc_func(bar), (1.0, 2.0)) == ((1.0, 2.0), 0.0)
        @test with_logabsdet_jacobian(_bc_func(bar), [1.0, 2.0]) == ([1.0, 2.0], 0.0)
        @test with_logabsdet_jacobian(_bc_func(bar), (1.0, 2)) === NoLogAbsDetJacobian(_bc_func(bar), (1.0, 2))
        @test with_logabsdet_jacobian(Base.Fix1(map, bar), (1, 2.0)) === NoLogAbsDetJacobian(Base.Fix1(map, bar), (1, 2.0))
        @test with_logabsdet_jacobian(_bc_func(bar), Real[1.0, 2]) === NoLogAbsDetJacobian(_bc_func(bar), Real[1.0, 2])
        @test with_logabsdet_jacobian(Base.Fix1(map, bar), Real[1, 2.0]) === NoLogAbsDetJacobian(Base.Fix1(map, bar), Real[1, 2.0])
        @test with_logabsdet_jacobian(Base.Fix1(broadcast, bar), Real[1, 2]) === NoLogAbsDetJacobian(Base.Fix1(broadcast, bar), Real[1, 2])
    end

    @testset "with_logabsdet_jacobian on identity, adjoint and transpose" begin
        for f in (identity, adjoint, transpose)
            for arg in (x, A)
                test_with_logabsdet_jacobian(f, arg, getjacobian)
            end
        end
    end

    @testset "with_logabsdet_jacobian on inv" begin
        for arg in (x, A, CA)
            test_with_logabsdet_jacobian(inv, arg, getjacobian)
        end
    end

    @testset "with_logabsdet_jacobian on log and exp functions" begin
        for f in (+, -, exp, log, exp2, log2, exp10, log10, expm1, log1p)
            test_with_logabsdet_jacobian(f, x, getjacobian)
        end
    end
end

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).


"""
    struct FunctionWithLADJ{F,LADJF} <: Function

A function with an separate function to compute it's `logabddet(J)`.

Do not construct directly, use [`setladj(f, ladjf)`](@ref) instead.
"""
struct FunctionWithLADJ{F,LADJF} <: Function
    f::F
    ladjf::LADJF
end
FunctionWithLADJ(::Type{F}, ladjf::LADJF) where {F,LADJF} = FunctionWithLADJ{Type{F},LADJF}(F,ladjf)
FunctionWithLADJ(f::F, ::Type{LADJF}) where {F,LADJF} = FunctionWithLADJ{F,Type{LADJF}}(f,LADJF)
FunctionWithLADJ(::Type{F}, ::Type{LADJF}) where {F,LADJF} = FunctionWithLADJ{Type{F},Type{LADJF}}(F,LADJF)

(f::FunctionWithLADJ)(x) = f.f(x)

with_logabsdet_jacobian(f::FunctionWithLADJ, x) = f.f(x), f.ladjf(x)


"""
    setladj(f, ladjf)::Function

Return a function that behaves like `f` in general and which has
`with_logabsdet_jacobian(f, x) = f(x), ladjf(x)`.

Useful in cases where [`with_logabsdet_jacobian`](@ref) is not defined
for `f`, or if `f` needs to be assigned a LADJ-calculation that is
only valid within a given context, e.g. only for a
limited argument type/range that is guaranteed by the use case but
not in general, or that is optimized to a custom use case.

For example, `CUDA.CuArray` has no `with_logabsdet_jacobian` defined,
but may be used to switch computing device for a part of a
heterogenous computing function chain. Likewise, one may want to
switch numerical precision for a part of a calculation.

The function (wrapper) returned by `setladj` supports
[`InverseFunctions.inverse`](https://github.com/JuliaMath/InverseFunctions.jl)
if `f` does so.

Example:

```jldoctest setladj
# Increases precision before calculating exp:
foo = exp ∘ setladj(setinverse(Float64, Float32), _ -> 0)

# A log-value from some low-precision (e.g. GPU) computation:
log_x = Float32(100)

# f(log_x) would return Inf32 without going to Float64:
y, ladj = with_logabsdet_jacobian(foo, log_x)

r_log_x, ladj_inv = with_logabsdet_jacobian(inverse(foo), y)

ladj ≈ 100 ≈ -ladj_inv && r_log_x ≈ log_x

# output

true
```
"""
setladj(f, ladjf) = FunctionWithLADJ(_unwrap_f(f), ladjf)
export setladj

_unwrap_f(f) = f
_unwrap_f(f::FunctionWithLADJ) = f.f

# This file is a part of ChangesOfVariables.jl, licensed under the MIT License (MIT).

"""
    with_logabsdet_jacobian(f, x)

Computes both the transformed value of `x` under the transformation `f` and
the logarithm of the [volume element](https://en.wikipedia.org/wiki/Volume_element).

For `(y, ladj) = with_logabsdet_jacobian(f, x)`, the following must hold true:

* `y == f(x)`
* `ladj` is the `log(abs(det(jacobian(f, x))))`

`with_logabsdet_jacobian` comes with support for broadcasted/mapped functions
(via `Base.Broadcast.BroadcastFunction` or `Base.Fix1`) and `ComposedFunction`.

If no volume element is defined/applicable, `with_logabsdet_jacobian(f::F, x::T)`
returns [`NoLogAbsDetJacobian{F,T}()`](@ref).

# Examples

```jldoctest a
using ChangesOfVariables

foo(x) = inv(exp(-x) + 1)

function ChangesOfVariables.with_logabsdet_jacobian(::typeof(foo), x)
    y = foo(x)
    ladj = -x + 2 * log(y)
    (y, ladj)
end

x = 4.2
y, ladj_y = with_logabsdet_jacobian(foo, x)

using LinearAlgebra, ForwardDiff
y == foo(x) && ladj_y ≈ log(abs(ForwardDiff.derivative(foo, x)))

# output

true
```

```jldoctest a
X = rand(10)
broadcasted_foo = Base.Broadcast.BroadcastFunction(foo)
Y, ladj_Y = with_logabsdet_jacobian(broadcasted_foo, X)
Y == broadcasted_foo(X) && ladj_Y ≈ logabsdet(ForwardDiff.jacobian(broadcasted_foo, X))[1]

# output

true
```

```jldoctest a
z, ladj_z = with_logabsdet_jacobian(log ∘ foo, x)
z == log(foo(x)) && ladj_z == ladj_y + with_logabsdet_jacobian(log, y)[2]

# output

true
```

Implementations of with_logabsdet_jacobian can be tested (as a
`Test.@testset`) using
[`ChangesOfVariables.test_with_logabsdet_jacobian`](@ref).
"""
function with_logabsdet_jacobian end
export with_logabsdet_jacobian



"""
    struct NoLogAbsDetJacobian{F,T}

An instance `NoLogAbsDetJacobian{F,T}()` signifies that `with_logabsdet_jacobian(::F, ::T)` is not defined.

Constructors:
```julia
NoLogAbsDetJacobian(f, x)
NoLogAbsDetJacobian{F,T}()
```
"""
struct NoLogAbsDetJacobian{F,T} end
export NoLogAbsDetJacobian

@inline NoLogAbsDetJacobian(::F, ::T) where {F,T} = NoLogAbsDetJacobian{F,T}()
@inline NoLogAbsDetJacobian(::Type{F}, ::T) where {F,T} = NoLogAbsDetJacobian{Type{F},T}()
@inline NoLogAbsDetJacobian(::F, ::Type{T}) where {F,T} = NoLogAbsDetJacobian{F,Type{T}}()
@inline NoLogAbsDetJacobian(::Type{F}, ::Type{T}) where {F,T} = NoLogAbsDetJacobian{Type{F},Type{T}}()

with_logabsdet_jacobian(f, x) = NoLogAbsDetJacobian(f, x)


function with_logabsdet_jacobian(f::Base.ComposedFunction, x)
    y_ladj_inner = with_logabsdet_jacobian(f.inner, x)
    if y_ladj_inner isa NoLogAbsDetJacobian
        NoLogAbsDetJacobian(f, x)
    else
        y_inner, ladj_inner = y_ladj_inner
        y_ladj_outer = with_logabsdet_jacobian(f.outer, y_inner)
        if y_ladj_outer isa NoLogAbsDetJacobian
            NoLogAbsDetJacobian(f, x)
        else
            y, ladj_outer = y_ladj_outer
            (y, ladj_inner + ladj_outer)
        end
    end
end


_get_all_first(x) = map(first, x)
_get_second(x) = x[2]
# Use _get_second instead of last, using last causes horrible performance in Zygote here:
_sum_over_second(x) = sum(_get_second, x)

_combine_y_ladj(l, r) = ((l[1]..., r[1]), l[2] + r[2])

_with_ladj_on_mapped(y_with_ladj::Tuple{Any,Any}, ::NoLogAbsDetJacobian) = y_with_ladj

function _with_ladj_on_mapped(y_with_ladj::Tuple{Tuple{Any,Any}, Vararg{Tuple{Any,Any}}}, ::NoLogAbsDetJacobian)
    a, bs = first(y_with_ladj), Base.tail(y_with_ladj)
    return foldl(_combine_y_ladj, bs, init = ((a[1],), a[2]))
end

_with_ladj_on_mapped(y_with_ladj::Tuple{Vararg{Union{Tuple{Any,Any},NoLogAbsDetJacobian}}}, noladj::NoLogAbsDetJacobian) = noladj

function _with_ladj_on_mapped(y_with_ladj::AbstractArray{<:Tuple{Any,Any}}, ::NoLogAbsDetJacobian)
    y = _get_all_first(y_with_ladj)
    ladj = _sum_over_second(y_with_ladj)
    (y, ladj)
end

_with_ladj_on_mapped(::Any, noladj::NoLogAbsDetJacobian) = noladj

function with_logabsdet_jacobian(mapped_f::Base.Broadcast.BroadcastFunction, X)
    f = mapped_f.f
    y_with_ladj = broadcast(Base.Fix1(with_logabsdet_jacobian, f), X)
    _with_ladj_on_mapped(y_with_ladj, NoLogAbsDetJacobian(mapped_f, X))
end

function with_logabsdet_jacobian(mapped_f::Base.Fix1{<:Union{typeof(map),typeof(broadcast)}}, X)
    map_or_bc = mapped_f.f
    f = mapped_f.x
    y_with_ladj = map_or_bc(Base.Fix1(with_logabsdet_jacobian, f), X)
    _with_ladj_on_mapped(y_with_ladj, NoLogAbsDetJacobian(mapped_f, X))
end


with_logabsdet_jacobian(::typeof(identity), x) = (identity(x), zero(eltype(x)))

_ndof(::Type{<:Real}) = 1
_ndof(::Type{<:Complex}) = 2
with_logabsdet_jacobian(::typeof(inv), x::Number) = (inv(x), -2 * _ndof(typeof(x)) * log(abs(x)))
with_logabsdet_jacobian(::typeof(inv), A::AbstractMatrix) = (inv(A), -2 * _ndof(eltype(A)) * size(A, 1) * logabsdet(A)[1])

with_logabsdet_jacobian(::typeof(adjoint), x) = (adjoint(x), zero(eltype(x)))
with_logabsdet_jacobian(::typeof(transpose), x) = (transpose(x), zero(eltype(x)))

with_logabsdet_jacobian(::typeof(+), x) = (+(x), zero(eltype(x)))
with_logabsdet_jacobian(::typeof(-), x) = (-(x), zero(eltype(x)))

with_logabsdet_jacobian(::typeof(exp), x) = (exp(x), x)
with_logabsdet_jacobian(::typeof(exp2), x) = (exp2(x), log(2) * x + log(log(oftype(x, 2))))
with_logabsdet_jacobian(::typeof(exp10), x) = (exp10(x), log(10) * x + log(log(oftype(x, 10))))
with_logabsdet_jacobian(::typeof(expm1), x) = (expm1(x), x)

with_logabsdet_jacobian(::typeof(log), x) = (y = log(x); (y, -y))
with_logabsdet_jacobian(::typeof(log2), x) = (y = log2(x); (y, -log(2) * y - log(log(oftype(x, 2)))))
with_logabsdet_jacobian(::typeof(log10), x) = (y = log10(x); (y, -log(10) * y - log(log(oftype(x, 10)))))
with_logabsdet_jacobian(::typeof(log1p), x) = (y = log1p(x); (y, -y))

# ChangesOfVariables.jl

```@docs
ChangesOfVariables
```

This package defines the function [`with_logabsdet_jacobian`](@ref). `(y, ladj) = with_logabsdet_jacobian(f, x)` computes both the transformed value of `x` under the transformation `f` and the logarithm of the [volume element](https://en.wikipedia.org/wiki/Volume_element).

`with_logabsdet_jacobian` supports mapped/broadcasted functions (via `Base.Broadcast.BroadcastFunction` or `Base.Fix1`) and function composition.

Implementations of `with_logabsdet_jacobian(f)` for `identity`, `inv`, `adjoint` and `transpose` as well as for `exp`, `log`, `exp2`, `log2`, `exp10`, `log10`, `expm1` and `log1p` are included.

# API

## Interface

```@docs
with_logabsdet_jacobian
NoLogAbsDetJacobian
setladj
```

## Test utility

```@docs
ChangesOfVariables.test_with_logabsdet_jacobian
```

## Additional functionality

```@docs
ChangesOfVariables.FunctionWithLADJ
```
